require("lib/states/GameState")

IngameUNOState = IngameUNOState or class(GameState)

function IngameUNOState:init(game_state_machine)
	IngameUNOState.super.init(self, "ingame_uno", game_state_machine)
end

function IngameUNOState:at_enter()
	managers.uno:setup_controllers()

	local hud = managers.hud:script(IngameWaitingForPlayersState.GUI_SAFERECT)

	if self._hud_chat_access then
		self._hud_chat_access:remove()
	end
	self._hud_chat_access = HUDChat:new(managers.hud._saferect, hud)

	managers.hud._hud_chat = self._hud_chat_access
	managers.hud:show(IngameWaitingForPlayersState.GUI_SAFERECT)
end

function IngameUNOState:at_exit()
	managers.uno:remove_controllers()

	managers.environment_controller:set_dof_distance()
	managers.hud:hide(IngameWaitingForPlayersState.GUI_SAFERECT)
	managers.hud._hud_chat = nil

	if self._hud_chat_access then
		self._hud_chat_access:remove()
	end
end

function IngameUNOState:on_server_left()
	IngameCleanState.on_server_left(self)
end

function IngameUNOState:on_kicked()
	IngameCleanState.on_kicked(self)
end

function IngameUNOState:on_disconnected()
	IngameCleanState.on_disconnected(self)
end