PlayerUNO = PlayerUNO or class(CardHolderUNO)

function PlayerUNO:init(position, rotation)
	PlayerUNO.super.init(self)

	self._position = position
	self._rotation = rotation

	-- self._hovering_index = 0
end

-- function PlayerUNO:update(t, dt)
-- 	local max_distance = 75
-- 	local smallest_distance = 9999999
-- 	local smallest_index = 0

-- 	for index, _ in pairs(self._cards) do
-- 		local card_pos, card_rot = self:_calculate_card_pos_rot(index)
-- 		local screen_pos = workspace:world_to_screen(self._camera, card_pos)

-- 		local distance = mvector3.distance(screen_pos, Vector3(mouse_x, mouse_y, 0))

-- 		if distance < smallest_distance and distance < max_distance then
-- 			smallest_distance = distance
-- 			smallest_index = index
-- 		end
-- 	end

-- 	if self._draw_pile and self._draw_pile:card_amount() > 0 then
-- 		local card_pos = self._draw_pile:bottom_card():position()
-- 		local screen_pos = workspace:world_to_screen(self._camera, card_pos)
-- 		local distance = mvector3.distance(screen_pos, Vector3(mouse_x, mouse_y, 0))

-- 		if distance < smallest_distance and distance < max_distance then
-- 			smallest_distance = distance
-- 			smallest_index = -1
-- 		end
-- 	end

-- 	if smallest_index ~= self._hovering_index then
-- 		self._hovering_index = smallest_index
-- 		self:update_cards()

-- 		if smallest_index == -1 then
-- 			self._draw_pile:bottom_card():set_border_enabled(true)
-- 		elseif self._draw_pile:bottom_card() then
-- 			self._draw_pile:bottom_card():set_border_enabled(false)
-- 		end
-- 	end

-- 	if self._hovering_index > 0 then
-- 		managers.mouse_pointer:set_pointer_image("hand")
-- 	else
-- 		managers.mouse_pointer:set_pointer_image("arrow")
-- 	end
-- end

-- function PlayerUNO:mouse_pressed(o, button, x, y)
-- 	if button == Idstring("0") then
-- 		if self._hovering_index == -1 then
-- 			managers.uno:draw_card()
-- 			self._hovering_index = 0
-- 			return
-- 		end

-- 		local card = self:get_card(self._hovering_index)
-- 		if card then
-- 			card:set_border_enabled(false)
-- 			managers.uno:play_card(card)
-- 		end
-- 	elseif button == Idstring("1") then
-- 		self:set_fov_target(50)
-- 	end
-- end

-- function PlayerUNO:mouse_released(o, button, x, y)
-- 	if button == Idstring("1") then
-- 		self:set_fov_target(70)
-- 	end
-- end

function PlayerUNO:_calculate_card_pos_rot(index, extra_back, extra_down)
	local total_twist = 20

	local total_width = 40
	local total_height = 5

	local base_position = self._position + (self._rotation:y() * 40) + (self._rotation:z() * -15)
	local base_rotation = self._rotation * Rotation(180, 30, 0)

	local card_count = #self._cards
	local percentage = index / (card_count + 1)
	local split_percentage = percentage - 0.5

	local card_twist = split_percentage * total_twist

	local card_back = (index * -0.3) + (extra_back or 0)
	local card_left = split_percentage * total_width
	local card_down = (math.sin(percentage * 180) * total_height) + (extra_down or 0)

	local new_pos = base_position + (base_rotation:y() * card_back) + (base_rotation:x() * -card_left) + (base_rotation:z() * card_down)
	local new_rot = base_rotation * Rotation(0, 0, -card_twist)

	return new_pos, new_rot
end

function PlayerUNO:update_cards()
	for index, card in pairs(self._cards) do
		local extra_back = 0
		local extra_down = 0

		if index == self._hovering_index then
			extra_back = 3
			extra_down = 2
			card:set_border_enabled(true)
		else
			card:set_border_enabled(false)
		end

		local new_pos, new_rot = self:_calculate_card_pos_rot(index, extra_back, extra_down)

		card:set_position_target(new_pos)
		card:set_rotation_target(new_rot)

		card:set_face_visible(true)
	end
end