UNOCardHolder = UNOCardHolder or class()

function UNOCardHolder:init()
	self._cards = {}
end

function UNOCardHolder:bottom_card()
	return self._cards[1]
end

function UNOCardHolder:top_card()
	return self._cards[#self._cards]
end

function UNOCardHolder:cards()
	return self._cards
end

function UNOCardHolder:get_card(index)
	return self._cards[index]
end

function UNOCardHolder:remove_card(card)
	local new_cards = {}
	for _, old_card in pairs(self._cards) do
		if old_card ~= card then
			table.insert(new_cards, old_card)
		end
	end
	self._cards = new_cards

	self:update_cards()
end

function UNOCardHolder:add_card(card)
	table.insert(self._cards, card)

	self:update_cards()
end

function UNOCardHolder:card_amount()
	return #self._cards
end

function UNOCardHolder:update_cards() end

function UNOCardHolder:destroy_cards()
	for _, card in pairs(self._cards) do
		card:destroy()
	end

	self._cards = {}
end

function UNOCardHolder:destroy()
	self:destroy_cards()
end