UNOCardSelector = UNOCardSelector or class(UNOHand)

function UNOCardSelector:init(position, rotation)
	UNOCardSelector.super.init(self, position, rotation)

	self._callbacks = {}
end

function UNOCardSelector:set_callback(index, clbk)
	self._callbacks[index] = clbk
end

function UNOCardSelector:distance(x, y)
	return 0
end

function UNOCardSelector:inside(x, y)
	return self:card_amount() > 0
end

function UNOCardSelector:_calculate_card_pos_rot(index, extra_back, extra_down, extra_left, cant_see_cards)
	local total_twist = 20

	local total_width = 40
	local total_height = 5

	local base_position = self._position + (self._rotation:y() * 40) + (self._rotation:z() * -10)
	local base_rotation = self._rotation * Rotation(180, -10, 0)

	if cant_see_cards then
		base_rotation = base_rotation * Rotation(0, -60, 0)
	end

	local card_count = #self._cards
	local percentage = index / (card_count + 1)
	local split_percentage = percentage - 0.5

	local card_twist = split_percentage * total_twist

	local card_back = (index * -0.05) + (extra_back or 0)
	local card_left = (split_percentage * total_width) - (extra_left or 0)
	local card_down = (math.sin(percentage * 180) * total_height) + (extra_down + 8 or 0)

	local new_pos = base_position + (base_rotation:y() * card_back) + (base_rotation:x() * -card_left) + (base_rotation:z() * card_down)
	local new_rot = base_rotation * Rotation(0, 0, -card_twist)

	return new_pos, new_rot
end

function UNOCardSelector:mouse_pressed(button, x, y, selected)
	if self._controller and self._controller:is_turn() and button == Idstring("0") then
		if self._current_card and selected then
			if self._callbacks[self._current_card_index] then
				self._callbacks[self._current_card_index](self._current_card)

				self._current_card = nil
				self._current_card_index = nil

				self:destroy_cards()

				self._callbacks = {}
			end
		end
	end
end