UNOControllable = UNOControllable or class()

function UNOControllable:setup_controller(controller)
	self._controller = controller
end

function UNOControllable:remove_controller()
	self._controller = false
end

function UNOControllable:distance(x, y) return 0 end
local temp_distance_vec = Vector3()
function UNOControllable:_distance_helper(x, y, position)
	if not self._controller then return 0 end
	if not self._controller.to_screen then return 0 end

	mvector3.set_x(temp_distance_vec, x)
	mvector3.set_y(temp_distance_vec, y)

	local screen_position = self._controller:to_screen(position)
	mvector3.set_z(screen_position, 0)

	return mvector3.distance(temp_distance_vec, screen_position)
end

function UNOControllable:inside(x, y) end
function UNOControllable:update(t, dt, x, y, selected) end
function UNOControllable:mouse_pressed(x, y, selected) end
function UNOControllable:mouse_released(x, y, selected) end

UNOControllableCardHolder = UNOControllableCardHolder or class(UNOCardHolder)
mixin(UNOControllableCardHolder, UNOControllable)

function UNOControllableCardHolder:inside_card(card, x, y, override_position)
	if not self._controller then return false end
	if not self._controller.to_screen then return false end

	local corners = card:corners(override_position)
	local screen_corners = {}
	for index, corner in pairs(corners) do
		screen_corners[index] = self._controller:to_screen(corner)
	end

	local inside = false
	local second_index = #screen_corners

	for index = 1, #screen_corners do
		local screen_corner_1 = screen_corners[index]
		local screen_corner_2 = screen_corners[second_index]

		local scr1_x = screen_corner_1.x
		local scr1_y = screen_corner_1.y
		local scr2_x = screen_corner_2.x
		local scr2_y = screen_corner_2.y

		if (((scr1_y > y) ~= (scr2_y > y)) and (x < (scr2_x - scr1_x) * (y-scr1_y) / (scr2_y-scr1_y) + scr1_x)) then
			inside = not inside
		end

		second_index = index
	end

	return inside
end